Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,37 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::statistics_deallocation"
+  void Icache_Access::statistics_deallocation (void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+    
+    delete    _stat;
+    delete [] _stat_nb_access;
+    delete [] _stat_nb_access_conflit;
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_transition.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_transition.cpp	(revision 88)
@@ -0,0 +1,54 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::transition"
+  void Icache_Access::transition (void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    if (PORT_READ(in_NRESET) == 0)
+      {
+	_priority->reset();
+      }
+    else
+      {
+	// next priority
+	_priority->transition();
+
+#ifdef STATISTICS
+        if (usage_is_set(_usage,USE_STATISTICS))
+          for (uint32_t i=0; i<_param->_nb_icache_port;i++)
+            {
+              (*_stat_nb_access         [i]) += _internal_ICACHE_REQ_NB_ACCESS         [i];
+              (*_stat_nb_access_conflit [i]) += _internal_ICACHE_REQ_NB_ACCESS_CONFLIT [i];
+            }
+#endif
+      }
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl.cpp	(revision 88)
@@ -0,0 +1,44 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::vhdl"
+  void Icache_Access::vhdl (void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl_body.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl_body.cpp	(revision 88)
@@ -0,0 +1,31 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::vhdl_body"
+  void Icache_Access::vhdl_body (Vhdl * & vhdl)
+  {
+    log_begin(Icache_Access,FUNCTION);
+    vhdl->set_body ("");
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl_declaration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl_declaration.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_vhdl_declaration.cpp	(revision 88)
@@ -0,0 +1,30 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::vhdl_declaration"
+  void Icache_Access::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_begin(Icache_Access,FUNCTION);
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters.cpp	(revision 88)
@@ -0,0 +1,145 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Parameters.h"
+#include "Common/include/Max.h"
+#include "Common/include/BitManipulation.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::Parameters"
+  Parameters::Parameters (uint32_t             nb_thread                  ,
+			  uint32_t             nb_front_end               ,
+			  uint32_t           * nb_context                 ,
+			  uint32_t             nb_icache_port             ,
+			  uint32_t             size_address               ,
+                          uint32_t             size_icache_thread_id      ,
+                          uint32_t             size_icache_packet_id      ,
+			  uint32_t          ** nb_instruction             ,
+			  uint32_t          ** size_packet_id             ,
+			  uint32_t          ** table_routing              ,
+			  Tpriority_t          priority                   ,
+			  Tload_balancing_t    load_balancing             ,
+                          uint32_t          ** translate_context_to_thread,
+                          bool                 is_toplevel   )
+  {
+    log_begin(Icache_Access,FUNCTION);
+    
+    _nb_thread                     = nb_thread     ;
+    _nb_front_end                  = nb_front_end  ;
+    _nb_context                    = nb_context    ;
+    _nb_icache_port                = nb_icache_port;
+    _size_address                  = size_address  ;
+    _size_icache_thread_id         = size_icache_thread_id;
+    _size_icache_packet_id         = size_icache_packet_id;
+    _nb_instruction                = nb_instruction;
+    _size_packet_id                = size_packet_id;
+    _table_routing                 = table_routing ;
+    _priority                      = priority      ;
+    _load_balancing                = load_balancing;
+    _translate_context_to_thread   = translate_context_to_thread;
+
+    test();
+
+    _have_port_icache_thread_id    = _size_icache_thread_id>0;
+    _have_port_icache_packet_id    = _size_icache_packet_id>0;
+
+
+    _translate_thread_to_context   = new Tcontext_t [_nb_thread];
+    _translate_thread_to_front_end = new Tcontext_t [_nb_thread];
+
+    for (uint32_t i=0; i<_nb_front_end; ++i)
+      for (uint32_t j=0; j<_nb_context[i]; ++j)
+        {
+          uint32_t num_thread = translate_context_to_thread[i][j];
+          
+          _translate_thread_to_context   [num_thread] = i;
+          _translate_thread_to_front_end [num_thread] = j;
+        }
+
+    _icache_nb_instruction   = new uint32_t [_nb_icache_port];
+    for (uint32_t i=0; i<_nb_icache_port; ++i)
+      _icache_nb_instruction [i] = 0;
+    for (uint32_t i=0; i<_nb_front_end; i++)
+      for (uint32_t j=0; j<_nb_context[i]; j++)
+        {
+          uint32_t port = _table_routing [i][j];
+
+          // Take the greater
+          if (_icache_nb_instruction[port] < _nb_instruction [i][j])
+            _icache_nb_instruction[port] = _nb_instruction [i][j];
+        }
+    
+    _have_port_packet_id     = new bool * [_nb_front_end];
+    for (uint32_t i=0; i<_nb_front_end; i++)
+      {
+	_have_port_packet_id [i] = new bool [_nb_context [i]];
+	
+	for (uint32_t j=0; j<_nb_context[i]; j++)
+	  _have_port_packet_id [i][j] = _size_packet_id [i][j] > 0;
+      }
+   
+    _max_nb_context          = max<uint32_t>(_nb_context,_nb_front_end);
+    _max_nb_instruction      = max<uint32_t>(_nb_instruction,_nb_front_end,_nb_context);
+    _size_thread_id          = log2(_nb_front_end) + log2(_max_nb_context);
+    _max_size_packet_id      = max<uint32_t>(_size_packet_id,_nb_front_end, _nb_context);
+    
+    _shift_num_front_end     = log2(_max_nb_context);
+    _mask_size_context       = gen_mask<Tcontext_t>(log2(_max_nb_context));
+  
+    if (is_toplevel)
+      {
+        copy ();
+      }
+
+    log_end(Icache_Access,FUNCTION);
+  };
+  
+// #undef  FUNCTION
+// #define FUNCTION "Icache_Access::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param)
+//   {
+//     log_begin(Icache_Access,FUNCTION);
+//     test();
+//     log_end(Icache_Access,FUNCTION);
+//   };
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::~Parameters"
+  Parameters::~Parameters (void) 
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    for (uint32_t i=0; i<_nb_front_end; i++)
+      delete [] _have_port_packet_id [i];
+    delete [] _have_port_packet_id;
+    delete [] _icache_nb_instruction;
+
+    delete [] _translate_thread_to_front_end;
+    delete [] _translate_thread_to_context  ;
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::copy"
+  void Parameters::copy (void) 
+  {
+    log_begin(Icache_Access,FUNCTION);
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_msg_error.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_msg_error.cpp	(revision 88)
@@ -0,0 +1,71 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Icache_Access/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::msg_error"
+  Parameters_test Parameters::msg_error(void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    Parameters_test test ("Icache_Access");
+
+    bool have_link [_nb_icache_port];
+    for (uint32_t i=0; i<_nb_icache_port; i++)
+      have_link [i] = 0;
+
+    for (uint32_t i=0; i<_nb_front_end; i++)
+      for (uint32_t j=0; j<_nb_context [i]; j++)
+	if (_table_routing [i][j] >= _nb_icache_port)
+	  test.error(toString(_("table_routing [%d][%d] : invalid value, must be < nb_icache_port.\n"),i,j));
+	else
+	  have_link [_table_routing [i][j]] = true;
+
+    for (uint32_t i=0; i<_nb_icache_port; i++)
+      if (not have_link [i])
+	test.error(toString(_("Port[%d] is not linked.\n"),i));
+
+    bool thread_link [_nb_thread];
+    for (uint32_t i=0; i<_nb_thread; ++i)
+      thread_link [i] = false;
+    
+    for (uint32_t i=0; i<_nb_front_end; i++)
+      for (uint32_t j=0; j<_nb_context [i]; j++)
+        {
+          uint32_t num_thread = _translate_context_to_thread [i][j];
+          if (num_thread >= _nb_thread)
+            test.error(toString(_("Context [%d][%d] is linked with an invalid thread id.\n"),i,j));
+          else
+            if (thread_link [num_thread] == true)
+              test.error(toString(_("Context [%d][%d] is linked with an already used thread id.\n"),i,j));
+            else
+              thread_link [num_thread] = true;
+        }
+
+    for (uint32_t i=0; i<_nb_thread; ++i)
+      if (not thread_link [i])
+        test.error(toString(_("Thread [%d] is not linked.\n"),i));
+
+    log_end(Icache_Access,FUNCTION);
+
+    return test;
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Parameters_print.cpp	(revision 88)
@@ -0,0 +1,78 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    XML xml ("icache_access");
+
+    xml.balise_open("icache_access");
+    xml.singleton_begin("nb_front_end           "); xml.attribut("value",toString(_nb_front_end           )); xml.singleton_end();
+    xml.singleton_begin("nb_icache_port         "); xml.attribut("value",toString(_nb_icache_port         )); xml.singleton_end();
+    xml.singleton_begin("size_address           "); xml.attribut("value",toString(_size_address           )); xml.singleton_end();
+    xml.singleton_begin("priority               "); xml.attribut("value",toString(_priority               )); xml.singleton_end();
+    xml.singleton_begin("load_balancing         "); xml.attribut("value",toString(_load_balancing         )); xml.singleton_end();
+    for (uint32_t i=0;i<_nb_front_end; i++)
+      {
+        xml. balise_open_begin("component");
+        xml.  attribut("type","front_end");
+        xml.  attribut("id"  ,toString(i));
+        xml. balise_open_end();
+	xml.singleton_begin("nb_context             "); xml.attribut("value",toString(_nb_context             [i])); xml.singleton_end();
+
+	for (uint32_t j=0;j<_nb_context [i]; j++)
+	  {
+	    xml. balise_open_begin("component");
+	    xml.  attribut("type","context");
+	    xml.  attribut("id"  ,toString(j));
+	    xml. balise_open_end();
+	    xml.singleton_begin("nb_instruction         "); xml.attribut("value",toString(_nb_instruction         [i][j])); xml.singleton_end();
+	    xml.singleton_begin("size_packet_id         "); xml.attribut("value",toString(_size_packet_id         [i][j])); xml.singleton_end();
+	    xml.singleton_begin("table_routing          "); xml.attribut("value",toString(_table_routing          [i][j])); xml.singleton_end();
+	    xml. balise_close();
+	  }
+        xml. balise_close();
+      }
+
+    xml.balise_close();
+
+    log_end(Icache_Access,FUNCTION);
+    
+    return xml.get_body(depth);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::icache_access::Parameters & x)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    output_stream << x.print(0);
+    
+    log_end(Icache_Access,FUNCTION);
+
+    return output_stream;
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libCore.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Makefile.deps	(revision 88)
@@ -0,0 +1,80 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Core			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+ifndef Icache_Access
+include 			$(DIR_MORPHEO)/Behavioural/Core/Icache_Access/Makefile.deps
+endif
+ifndef Dcache_Access
+include 			$(DIR_MORPHEO)/Behavioural/Core/Dcache_Access/Makefile.deps
+endif
+ifndef Multi_Front_end
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Makefile.deps
+endif
+ifndef Multi_OOO_Engine
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Makefile.deps
+endif
+ifndef Multi_Execute_loop
+include 			$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Makefile.deps
+endif
+ifndef Core_Glue
+include 			$(DIR_MORPHEO)/Behavioural/Core/Core_Glue/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Core_DIR			=	$(DIR_MORPHEO)/Behavioural/Core
+
+#-----[ Library ]------------------------------------------
+
+Core_LIBRARY    		= 	-lCore                          \
+					$(Icache_Access_LIBRARY)        \
+					$(Dcache_Access_LIBRARY)        \
+					$(Front_end_LIBRARY)            \
+					$(OOO_Engine_LIBRARY)           \
+					$(Execute_loop_LIBRARY)         \
+					$(Core_Glue_LIBRARY)            \
+					$(Behavioural_LIBRARY)	
+
+Core_DIR_LIBRARY		=	-L$(Core_DIR)/lib               \
+					$(Icache_Access_DIR_LIBRARY)    \
+					$(Dcache_Access_DIR_LIBRARY)    \
+					$(Front_end_DIR_LIBRARY)        \
+					$(OOO_Engine_DIR_LIBRARY)       \
+					$(Execute_loop_DIR_LIBRARY)     \
+					$(Core_Glue_DIR_LIBRARY)        \
+					$(Behavioural_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Core_library		:
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) Icache_Access_library;		\
+				$(MAKE) Dcache_Access_library;		\
+				$(MAKE) Front_end_library;		\
+				$(MAKE) OOO_Engine_library;		\
+				$(MAKE) Execute_loop_library;		\
+				$(MAKE) Core_Glue_library;		\
+				$(MAKE) --directory=$(Core_DIR) --makefile=Makefile;
+
+Core_library_clean	:
+				@\
+				$(MAKE) Behavioural_library_clean;	\
+				$(MAKE) Icache_Access_library_clean;	\
+				$(MAKE) Dcache_Access_library_clean;	\
+				$(MAKE) Front_end_library_clean;	\
+				$(MAKE) OOO_Engine_library_clean;	\
+				$(MAKE) Execute_loop_library_clean;	\
+				$(MAKE) Core_Glue_library_clean;	\
+				$(MAKE) --directory=$(Core_DIR) --makefile=Makefile clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libExecute_loop_Glue.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/Makefile.deps	(revision 88)
@@ -0,0 +1,38 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Execute_loop_Glue			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Execute_loop_Glue_DIR			=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue
+
+#-----[ Library ]------------------------------------------
+
+Execute_loop_Glue_LIBRARY		= 	-lExecute_loop_Glue	\
+					$(Behavioural_LIBRARY)	
+
+Execute_loop_Glue_DIR_LIBRARY		=	-L$(Execute_loop_Glue_DIR)/lib	\
+					$(Behavioural_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Execute_loop_Glue_library		:
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) --directory=$(Execute_loop_Glue_DIR) --makefile=Makefile;
+
+Execute_loop_Glue_library_clean	:
+				@\
+				$(MAKE) Behavioural_library_clean;	\
+				$(MAKE) --directory=$(Execute_loop_Glue_DIR) --makefile=Makefile clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,32 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Execute_loop_Glue_LIBRARY)
+
+DIR_LIBRARY			= $(Execute_loop_Glue_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Execute_loop_Glue_library
+
+library_clean			: Execute_loop_Glue_library_clean
+
+local_clean			:
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/configuration.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/configuration.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/configuration.cfg	(revision 88)
@@ -0,0 +1,8 @@
+Execute_loop_Glue
+1	4	*4	# nb_gpr_write         
+1	4	*4	# nb_spr_write         
+0	2	+1	# size_ooo_engine_id   
+6	6	*2	# size_general_register
+4	4	*2	# size_special_register
+32	32	*2	# size_general_data    
+2	2	*2	# size_special_data    
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,30 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  1
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/include/Execute_loop_Glue.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::core;
+using namespace morpheo::behavioural::core::multi_execute_loop;
+using namespace morpheo::behavioural::core::multi_execute_loop::execute_loop;
+
+using namespace morpheo::behavioural::core::multi_execute_loop::execute_loop::execute_loop_glue;
+
+void test    (string name,
+	      morpheo::behavioural::core::multi_execute_loop::execute_loop::execute_loop_glue::Parameters * param);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,86 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/SelfTest/include/test.h"
+
+#define NB_PARAMS 7
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * nb_gpr_write          (uint32_t)\n"));
+  err (_(" * nb_spr_write          (uint32_t)\n"));
+  err (_(" * size_ooo_engine_id    (uint32_t)\n"));
+  err (_(" * size_general_register (uint32_t)\n"));
+  err (_(" * size_special_register (uint32_t)\n"));
+  err (_(" * size_general_data     (uint32_t)\n"));
+  err (_(" * size_special_data     (uint32_t)\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  if (argc != static_cast<int>(2+NB_PARAMS))
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  string name = argv[x++];
+  uint32_t _nb_gpr_write           = fromString<uint32_t>(argv[x++]);
+  uint32_t _nb_spr_write           = fromString<uint32_t>(argv[x++]);
+  uint32_t _size_ooo_engine_id     = fromString<uint32_t>(argv[x++]);
+  uint32_t _size_general_register  = fromString<uint32_t>(argv[x++]);
+  uint32_t _size_special_register  = fromString<uint32_t>(argv[x++]);
+  uint32_t _size_general_data      = fromString<uint32_t>(argv[x++]);
+  uint32_t _size_special_data      = fromString<uint32_t>(argv[x++]);
+
+  int _return = EXIT_SUCCESS;
+  try 
+    {
+      morpheo::behavioural::core::multi_execute_loop::execute_loop::execute_loop_glue::Parameters * param = new morpheo::behavioural::core::multi_execute_loop::execute_loop::execute_loop_glue::Parameters
+	(
+	 _nb_gpr_write           ,
+	 _nb_spr_write           ,
+	 _size_ooo_engine_id     ,
+	 _size_general_register  ,
+	 _size_special_register  ,
+	 _size_general_data      ,
+	 _size_special_data      ,
+         true // is_toplevel
+        );
+      
+      msg(_("%s"),param->print(0).c_str());
+      
+      test (name,param);
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+  
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Execute_loop_Glue : no error");
+      else
+	TEST_KO("Execute_loop_Glue : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  return (_return);
+}
